<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <link
    rel="stylesheet"
    href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
    integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T"
    crossorigin="anonymous"
  />
  <title>Jest Speed Reporter</title>
  <style>
  /* To prevent the table from overflowing container */
  td {
    word-wrap: break-word;
    word-break: break-all;
  }
  </style>
</head>
<body>
<main class="container-fluid">
  <header class="mt-4 d-flex align-items-center">
    <h1>Jest Speed Reporter</h1>
    <span class="mx-1"> • </span>
  </header>
  <h2>
    Latest Pipeline
  </h2>
  <p>
    <a href="{{pipeline.web_url}}"> Latest Pipeline at {{pipeline.created_at}} </a>
  </p>
  <details>
    <summary>[latest pipeline] Slowest test groups</summary>
    <div class="table-responsive">
      <table class="table table-dark table-striped mt-4">
        <thead>
        <tr>
          <th style="width: 20%;">Test group</th>
          <th style="width: 10%;">Slowest test time</th>
          <th style="width: 40%;">Slowest test</th>
          <th style="width: 10%;">Test group time</th>
          <th style="width: 10%;">Test count</th>
          <th style="width: 10%;">Average</th>
        </tr>
        </thead>
        <tbody>
        {{#testSuites}}
          <tr>
            <td>{{ name }}</td>
            <td>{{ slowest.time }}s</td>
            <td>{{ slowest.name }}</td>
            <td>{{ time }}s</td>
            <td>{{ tests }}</td>
            <td>{{ average }}</td>
          </tr>
        {{/testSuites}}
        </tbody>
      </table>
    </div>
  </details>
  <details>
    <summary>[latest pipeline] {{slowestTests.length}} slowest tests</summary>
    <div class="table-responsive">
      <table class="table table-dark table-striped mt-4">
        <thead>
        <tr>
          <th style="width: 80%;">Name</th>
          <th style="width: 20%;">time</th>
        </tr>
        </thead>
        <tbody>
        {{#slowestTests}}
          <tr>
            <td>{{ name }} / {{ file }}</td>
            <td>{{ time }}s</td>
          </tr>
        {{/slowestTests}}
        </tbody>
      </table>
    </div>
  </details>
  <h2>
    Over time
  </h2>
  <p>
    The tables below show the average / median etc over the latest {{overTimeCount}} pipelines
    The standard deviation of the range is: {{stdDevRange}}
  </p>
  <details>
    <summary>[over time] Slowest test groups</summary>
    <div class="table-responsive">
      <table class="table table-dark table-striped mt-4">
        <thead>
        <tr>
          <th style="width: 40%;">Test group</th>
          <th style="width: 10%;">Min Avg</th>
          <th style="width: 10%;">Med Avg</th>
          <th style="width: 10%;">Max Avg</th>
        </tr>
        </thead>
        <tbody>
        {{#testSuitesOverTime}}
          <tr>
            <td>{{ file }}<br><small>{{{ name }}}</small></td>
            <td>{{ minAvg }}s</td>
            <td>{{ medAvg }}s</td>
            <td>{{ maxAvg }}s</td>
          </tr>
        {{/testSuitesOverTime}}
        </tbody>
      </table>
    </div>
  </details>
  <details>
    <summary>[over time] {{slowestTestsOverTime.length}} slowest tests</summary>
    <div class="table-responsive">
      <table class="table table-dark table-striped mt-4">
        <thead>
        <tr>
          <th style="width: 50%;">Name</th>
          <th style="width: 10%;">Min</th>
          <th style="width: 10%;">Med</th>
          <th style="width: 10%;">Max</th>
          <th style="width: 10%;">Dev</th>
          <th style="width: 10%;">Range</th>
        </tr>
        </thead>
        <tbody>
        {{#slowestTestsOverTime}}
          <tr>
            <td>{{ file }}<br><small>{{{ name }}}</small></td>
            <td>{{ minAvg }}s</td>
            <td>{{ medAvg }}s</td>
            <td>{{ maxAvg }}s</td>
            <td>{{ stdDev }}</td>
            <td>{{ range }}</td>
          </tr>
        {{/slowestTestsOverTime}}
        </tbody>
      </table>
    </div>
  </details>
</main>
</body>
</html>
